﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.Windows.Media.Imaging;
using System.IO;

namespace WPF_ImageCarousel
{
    public class ImageFromBytesConverter:IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                return ImageFromBytes((value as System.Data.Linq.Binary).ToArray());
            }
            else
            {
                return Binding.DoNothing;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion

        public BitmapImage ImageFromBytes(Byte[] bytes)
        {
            MemoryStream stream = new MemoryStream();

            // to work around quirk in Northwind database:
            int offset = 78;
            stream.Write(bytes, offset, bytes.Length - offset);
            // end workaround

            BitmapImage image = new BitmapImage();
            image.BeginInit();
            image.StreamSource = stream;
            image.EndInit();
            return image;
        }
    }
}
